/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TInputTypeparam.TInputTypeparamPath;
import de.ship.db.tables.TInputVariable.TInputVariablePath;
import de.ship.db.tables.records.TInputTypeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputType extends TableImpl<TInputTypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_type</code>
     */
    public static final TInputType T_INPUT_TYPE = new TInputType();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputTypeRecord> getRecordType() {
        return TInputTypeRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_type.pk_input_type</code>.
     */
    public final TableField<TInputTypeRecord, Integer> PK_INPUT_TYPE = createField(DSL.name("pk_input_type"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_type.inputtype</code>.
     */
    public final TableField<TInputTypeRecord, Integer> INPUTTYPE = createField(DSL.name("inputtype"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_type.has_valuelist</code>. Does this
     * input type need a value list? 1 = yes, 0 = no
     */
    public final TableField<TInputTypeRecord, Integer> HAS_VALUELIST = createField(DSL.name("has_valuelist"), SQLDataType.INTEGER.nullable(false), this, "Does this input type need a value list? 1 = yes, 0 = no");

    /**
     * The column <code>common_dd.t_input_type.inputtype_descr</code>. language
     * key for this input type
     */
    public final TableField<TInputTypeRecord, String> INPUTTYPE_DESCR = createField(DSL.name("inputtype_descr"), SQLDataType.CLOB.nullable(false), this, "language key for this input type");

    /**
     * The column <code>common_dd.t_input_type.lastchange</code>.
     */
    public final TableField<TInputTypeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_type.data_type</code>.
     */
    public final TableField<TInputTypeRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    private TInputType(Name alias, Table<TInputTypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputType(Name alias, Table<TInputTypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_type</code> table reference
     */
    public TInputType(String alias) {
        this(DSL.name(alias), T_INPUT_TYPE);
    }

    /**
     * Create an aliased <code>common_dd.t_input_type</code> table reference
     */
    public TInputType(Name alias) {
        this(alias, T_INPUT_TYPE);
    }

    /**
     * Create a <code>common_dd.t_input_type</code> table reference
     */
    public TInputType() {
        this(DSL.name("t_input_type"), null);
    }

    public <O extends Record> TInputType(Table<O> path, ForeignKey<O, TInputTypeRecord> childPath, InverseForeignKey<O, TInputTypeRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_TYPE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputTypePath extends TInputType implements Path<TInputTypeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputTypePath(Table<O> path, ForeignKey<O, TInputTypeRecord> childPath, InverseForeignKey<O, TInputTypeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputTypePath(Name alias, Table<TInputTypeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputTypePath as(String alias) {
            return new TInputTypePath(DSL.name(alias), this);
        }

        @Override
        public TInputTypePath as(Name alias) {
            return new TInputTypePath(alias, this);
        }

        @Override
        public TInputTypePath as(Table<?> alias) {
            return new TInputTypePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputTypeRecord, Integer> getIdentity() {
        return (Identity<TInputTypeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputTypeRecord> getPrimaryKey() {
        return Keys.PK_INPUT_TYPE;
    }

    @Override
    public List<UniqueKey<TInputTypeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_TYPE);
    }

    @Override
    public List<ForeignKey<TInputTypeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_TYPE__FK_INPUTTYPE_DESCR);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_INPUT_TYPE__FK_INPUTTYPE_DESCR, null);

        return _tCoreTranslationKey;
    }

    private transient TInputTypeparamPath _tInputTypeparam;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_typeparam</code> table
     */
    public TInputTypeparamPath tInputTypeparam() {
        if (_tInputTypeparam == null)
            _tInputTypeparam = new TInputTypeparamPath(this, null, Keys.T_INPUT_TYPEPARAM__FK_INPUTTYPEPARAM_INPUTTYPE.getInverseKey());

        return _tInputTypeparam;
    }

    private transient TInputVariablePath _tInputVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_variable</code> table
     */
    public TInputVariablePath tInputVariable() {
        if (_tInputVariable == null)
            _tInputVariable = new TInputVariablePath(this, null, Keys.T_INPUT_VARIABLE__FK_INPUTVAR_INPUTTYPE.getInverseKey());

        return _tInputVariable;
    }

    @Override
    public TInputType as(String alias) {
        return new TInputType(DSL.name(alias), this);
    }

    @Override
    public TInputType as(Name alias) {
        return new TInputType(alias, this);
    }

    @Override
    public TInputType as(Table<?> alias) {
        return new TInputType(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputType rename(String name) {
        return new TInputType(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputType rename(Name name) {
        return new TInputType(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputType rename(Table<?> name) {
        return new TInputType(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputType where(Condition condition) {
        return new TInputType(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputType where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputType where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputType where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputType where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputType where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputType where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputType where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputType whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputType whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
